!
subroutine LA30(A, B, C, D, X, Error)
! 'Progon3'  :
!., .     
!. . "-" 1996
real, intent(in):: A(:), B(:), C(:), D(:)
real:: X(:)
integer:: Error
real, allocatable:: P(:), Q(:), R(:), S(:), T(:)
real W
integer i, ii, n
!begin
  n=size(A)
  if (n<3) then
    Error=1; return
  end if
  allocate(P(n), Q(n), R(n), S(n), T(n))
  P(1)=0.0; Q(1)=0.0; R(1)=1.0
  do i=1, n-1
    ii=i+1
    W=A(i)+Q(i)*C(i)
    if (1.0+W==1.0) then
      deallocate(P, Q, R, S, T)
      Error=65; return
    end if
    P(ii)=(D(i)-P(i)*C(i))/W
    Q(ii)=-B(i)/W
    R(ii)=-R(i)*C(i)/W
  end do
  S(n)=1.0; T(n)=0.0
  do i=n-1, 1, -1
    ii=i+1
    S(i)=Q(ii)*S(ii)+R(ii)
    T(i)=Q(ii)*T(ii)+P(ii)
  end do
  W=A(n)+B(n)*S(1)+c(n)*S(n-1)
  if (1.0+W==1.0) then
    deallocate(P, Q, R, S, T)
    Error=65; return
  end if
  X(n)=(D(n)-B(n)*T(1)-C(n)*T(n-1))/W
  do i=1, n-1
    X(i)=S(i)*X(n)+T(i)
  end do
  deallocate(P, Q, R, S, T)
  Error=0; return
end subroutine LA30
